'Dit is een programma om een 27C64 eprom te vullen met lastige data
'(De data kan ook in een gedeelte van een 27C128 of 27C256)
'
'De data is code voor de afstemspanning voor het MG gedeelte van de NRD515
'De eprom is bestemd voor een BC-TUNE automaat met D/A converter
'tune bereik loopt van 600 - 1600 khz aangeboden in hexadecimaal-BCD code
'(alleen getallen 0 - 9 uit de mogelijkheden 0 - F)
'
'Uitbreiding is aangesloten op de stuursignalen van de displaydriver IC's
'op de frontplaatmodule. Ook het BC tune signaal zit daar aan vast.
'Vlak boven de up/down switch zijn twee printpaaltjes van 1mm geplaatst.
'Daar is het onderbroken BC tune op aangesloten. Tune-in en tune-uit.
'Geen uitbreidingen aan de RX print zelf, die kan nog steeds zonder
'soldeerwerk losgenomen worden. De uitbreiding zit eronder op de bodemplaat.
'
'In de array eprom() staan bytes, geen bits. 2764   -  64 kbit= 8kbyte
'De eprom loopt van 0 - 2000 Hex (0-F telling), bevat dus nogal wat lege
'plekken. Let op!!  2000Hex zijn wel 8192 plaatsen decimaal!!!!
'
'Dit programma (515bc2.bas) is een aangepaste versie voor
'4x BB212 varicap diodes ipv 8x 1SV100 (origineel)
'Met de originele afstem D's was te veel onderlinge ongelijkheid en
'daarom geen goede gelijkloop van de dubbele afstemkring.
'
DECLARE FUNCTION hexwaarde% (bcd%)
'
DIM eprom(8191) AS INTEGER            'de eprom array 65536/8 -1
'we beginnen al op nul, vandaar tot 8191 (8192-1)
'
DIM voltage(16) AS DOUBLE        'de varicap spanning, een beetje nauwkeurig
'
OPEN "515bc2.inf" FOR INPUT AS #1

'dit zijn de aangeboden (opgemeten) afstemspanningen voor de BB212
'formaat per regel: f in Khz, dan een komma en dan de afstemspanning in
'Volt met een amerikaanse decimale punt.
'Geexporteerd uit MS-excel in DOS formaat. Zet eerst in spreadsheet om te zien
'of er niet te veel afwijkingen zijn van een regelmatig (semi lineair) verband

DO WHILE NOT EOF(1)
        INPUT #1, fr%, uvar#
          IF RIGHT$(STR$(fr%), 2) = "50" THEN GOTO verder
          'is het een tussenliggende waarde, dan even overslaan

        voltage(INT(fr% / 100)) = uvar#

verder:
LOOP
CLOSE #1

'test routine of de varicap U is doorgekomen
PRINT : PRINT "Varicap spannings waardes"

FOR tt% = 6 TO 16
PRINT tt% * 100, voltage(tt%)
NEXT tt%

'array even vullen met dummy FFH code (=255),
'staat wel netjes na programmeren en wat terugzoeken

FOR tt% = 0 TO 8191
        eprom(tt%) = &HFF
NEXT tt%


'omreken truuk d/a converter voor de BB212, max U is lager door grotere
'delta C bij lagere delta U.
'voetspanning iets lager (1,5V ipv 2) en delta U ook iets lager (7,5V ipv 10V)
'00H wordt alleen 1,5 volt opstap spanning, = 0 volt uit d/a
'ffH wordt 7,5 volt uit d/a + 1,5 volt opstap = 9 volt totaal
'7.5/256 is stap spanning = 0.029296875
CONST ustap# = .029296875#
CONST uvoet# = 1.5


'controle file aanmaken
PRINT : PRINT "Controle file = 515test2.inf"

OPEN "515test2.inf" FOR OUTPUT AS #3
PRINT #3, "frekwentie", "tune-U", "D/A code decimaal"

PRINT
PRINT "Array waardes even opbouwen"

'de grote loop
FOR freq% = 6 TO 15     'de honderdtallen van frekwentie
 
  udown# = voltage(freq%) - uvoet#
  uup# = voltage(freq% + 1) - uvoet#

  'laagste U waarde al wegschrijven
  tussenwaarde% = INT((10 * (udown#) / ustap# + .5) / 10)
  eprom(hexwaarde%(freq% * 100)) = tussenwaarde%
 
  PRINT #3, freq% * 100, INT(1000 * udown# + .5) / 1000 + uvoet#, tussenwaarde%

  'udif# = uup# - udown#
  'de volgende methode is misschien iets nauwkeuriger
  udif# = voltage(freq% + 1) - voltage(freq%)

'verschil tussen boven-U en onder-U moet over 100 stappen verdeeld worden
'zo goed als dat gaat zonder teveel accumulerende afrondingsfouten

  stapwaarde# = udif# / 100

       
        FOR tussen% = 1 TO 99
            tussenFreq% = freq% * 100 + tussen%
            tune# = udown# + tussen% * stapwaarde#

            eprom(hexwaarde%(tussenFreq%)) = INT((10 * tune# / ustap# + .5) / 10)
            PRINT #3, tussenFreq%, INT(1000 * tune# + .5) / 1000 + uvoet#, INT((10 * tune# / ustap# + .5) / 10)
       
        NEXT tussen%

NEXT freq%


'De hoogste f waarde (1600) wegschrijven, deze is eigenlijk niet nodig
'bij het testen wel makkelijker indien wel aanwezig
 
tussenwaarde% = INT((10 * (voltage(16) - uvoet#) / ustap# + .5) / 10)
eprom(&H1600) = tussenwaarde%
PRINT #3, "1600", voltage(16), tussenwaarde%


' nog twee test waardes invullen
eprom(&H1700) = &HFF      'dat FF stond er overigens al......


'in de aanloop ernaartoe al de goede U eropzetten,
'geeft niet zo'n grote U zwiep bij handtune en switch over naar tune deel

'de invul waarde zelfde als nu in &H600
uwaarde% = eprom(&H600)
FOR u% = 501 TO 599     'decimale telling codes naar hex/BCD
  eprom(hexwaarde%(u%)) = uwaarde%
NEXT u%

'nu de invul waarde zelfde als in &H1600
uwaarde% = eprom(&H1600)
FOR u% = 1601 TO 1699
  eprom(hexwaarde%(u%)) = uwaarde%
NEXT u%

eprom(&H500) = &H0        'afregel waarde voor 2V (of 1,5V) (uvoet#) preset

'tijdelijke dumpfile dichtdoen
CLOSE #3


PRINT "Nu de array nog even wegschrijven..., dat duurt even!"

OPEN "515BC2.BIN" FOR BINARY AS #2

FOR tt% = 0 TO 8191
'rare werking put commando: moet in strings voor hex waardes!!
'anders 2 bytes per getal

   DAspanning$ = CHR$(eprom(tt%))
   PUT #2, , DAspanning$

NEXT tt%
CLOSE #2
PRINT "okido, 515bc2.bin created"

END

FUNCTION hexwaarde% (bcd%)
'vertaling van decimale waarde naar BCD gecodeerde hexwaarde

'reset startwaardes
hexwaarde% = 0
hex% = 0

'totaal/1000 = duizendtallen              x4096
duizendtal% = INT(bcd% / 1000)
hex% = duizendtal% * 4096

'+ (totaal - duizendtallen)/100 = honderdtallen       x256
honderdtal% = INT((bcd% - 1000 * duizendtal%) / 100)
hex% = hex% + honderdtal% * 256

'+ (totaal - duizendtallen - honderdtallen)/10 = tientallen      x16
tiental% = INT((bcd% - 1000 * duizendtal% - 100 * honderdtal%) / 10)
hex% = hex% + tiental% * 16

'+ (totaal - duizendtallen -honderdtallen -tientallen)=eenheden
eenheden% = bcd% - 1000 * duizendtal% - 100 * honderdtal% - 10 * tiental%
hex% = hex% + eenheden%

hexwaarde% = hex%
END FUNCTION

